SystemOrganization addCategory: #AMMStudio!
SystemOrganization addCategory: #'AMMStudio-Test'!

NCEllipseMorph subclass: #AMMObjectNode
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:32:57.212'!
defaultBorderWidth 

	^ 3! !

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'ci 5/28/2013 20:13:04.64'!
defaultHeight 

	^ 30
	
! !

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'ci 5/28/2013 20:12:58.993'!
defaultWidth

	^ 30
	
! !

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:32:57.232'!
newFor: anObject
	| node|
	
	node := self new.
	node object: anObject.
	
	^ node! !

!AMMObjectNode methodsFor: 'event handling' stamp: 'sw 5/27/2013 11:17:38.637'!
click

	self object toggleState.
	! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/29/2013 09:26:22.19'!
connectedNodes

	| nodes |
	nodes := OrderedCollection new.
	
	self connectedConstraints do: [ :ownConstraint | 
			| connectorMorph foreignConstraint | 
		connectorMorph := ownConstraint owner.
		foreignConstraint := connectorMorph constraints detect: 
			[:constrain | (constrain = ownConstraint) not].
		foreignConstraint inputs do: [ :node |
			nodes add: node
			]
	].

	^ nodes! !

!AMMObjectNode methodsFor: 'initialization' stamp: 'sw 5/27/2013 10:49:54.998'!
initialize 

	super initialize.

	self color: Color white.
	self borderWidth: self class defaultBorderWidth.
	self removeAllMorphs.
	self height: self class defaultHeight.
	self width: self class defaultWidth.
	
	self on: #click send: #click to: self.
	! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:32:57.198'!
object

	^ object! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/15/2013 10:15:11.027'!
object: anObject

	object := anObject.
	self setColor.! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 08:40:10.394'!
refresh 

	self setColor.! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/29/2013 09:39:43.918'!
removeConnectorToNode: aNode

	self connectedConstraints do: [ :ownConstraint | 
		| connectorMorph foreignConstraint | 
		connectorMorph := ownConstraint owner.
		foreignConstraint := connectorMorph constraints detect: 
			[:constrain | (constrain = ownConstraint) not].
		foreignConstraint inputs do: [ :node |
			(node = aNode)
				ifTrue: [ 
					connectorMorph delete. 
					^ self
				].
			]
		].	! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/29/2013 09:53:46.354'!
removeUnreferencedConnectors 

	self connectedNodes do:[ :connectedNode |
		((self object references includes: connectedNode object) or:
		( connectedNode object references includes: self object))
			ifFalse: [ self halt. self removeConnectorToNode: connectedNode ]
	
	].! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/28/2013 22:13:11.044'!
setColor 

	(self object isRoot)
	 ifTrue: [ self borderColor: Color red; 
		   			  borderWidth: self class defaultBorderWidth ].
	
	(self object state = #marked) 
		ifTrue: [ self color: Color green ]
		ifFalse: [ 
			(self object state = #active) 
				ifTrue: [ self color: Color yellow ]
				ifFalse: [ 
					(self object flag = #doneTraversal)
						ifTrue: [self color: Color lightGreen ]
						ifFalse: [self color: Color white ].					
					] 
			].! !

UiTextEditor subclass: #AMMTextEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMTextEditor methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2013 10:59:06.57'!
doIt: anEvent

	self morph editView doIt.
	^ true! !

UiTestCase subclass: #AMMObjectGraphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMObjectGraphTest class methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 12:49:52.069'!
exampleCollectionWithoutCircularyDepencies
	
	| objA objB objC coll |
	objA := AMMObject new size: 8.
	objB := AMMObject new size: 20.
	objC := AMMObject new size: 5.
	objA references add: objB; add:objC.	

	coll := OrderedCollection new
		add: objA; 
		add: objB;
		add: objC;
		yourself.
	^ coll! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 11:03:38.691'!
subjectClass

	^ AMMObjectGraph! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 11:06:11.201'!
testANewObjectGraphHasNoNodes

	self assert: sut objectNodes size == 0.
	self assert: sut submorphs size == 0.
	! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 14:26:42.366'!
testRenderingConnectsNodes
	

	sut objects: self class exampleCollectionWithoutCircularyDepencies.
	
	self assert: sut objectNodes isEmpty.

	sut render.
	self deny: sut objectNodes isEmpty.
	! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 11:13:52.694'!
testRenderingCreatesObjectNodes
	
	sut objects add: (AMMObject new size: 8).
	self assert: sut objectNodes isEmpty.
	sut render.
	self deny: sut objectNodes isEmpty.
	! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 14:26:57.258'!
testRenderingPreservesObjects
	
	self assert: sut objects isEmpty.
	sut objects: self class exampleCollectionWithoutCircularyDepencies.
	self deny: sut objects isEmpty.
	sut render.
	self deny: sut objects isEmpty.	! !

PasteUpMorph subclass: #AMMObjectsRepresentation
	instanceVariableNames: 'studio objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

AMMObjectsRepresentation subclass: #AMMHeap
	instanceVariableNames: 'heapCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMHeap class methodsFor: 'as yet unclassified' stamp: 'rm 5/6/2013 15:15:08.484'!
withSize: aHeapSize

	| heap |
	heap := AMMHeap new.
	heap extent: ((aHeapSize*10)@100);
		borderWidth: 0;
		color: Color transparent.
	1 to: aHeapSize do: [ :cellNumber | 
		| cell |
		cell := AMMHeapCell withId: cellNumber.
		cell position: ( (10*(cellNumber-1)) @ 0).
		cell lock.
		heap heapCollection add: cell.
	].
	^ heap! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 5/28/2013 22:37:37.479'!
clear

! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 5/28/2013 22:40:58.621'!
clearHeap

	" remove all submorphs and empty all dictionaries/ collections"

	self removeAllMorphs.! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 5/27/2013 10:30:07.848'!
createCells: amountOfCells

	"create entries for all objects"

	1 to: amountOfCells do: [ :cellNumber | 
		| cell |
		cell := AMMHeapCell withId: cellNumber.
		cell position: ( (10*(cellNumber-1)+self left) @ self top).
		cell lock.
		self addMorph: cell.
		self heapCollection add: cell.
	].
	! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 5/28/2013 23:54:08.705'!
freeEmptiedCells

	self submorphs do: [ :cell |
		(self objects includes: cell object) 
			ifFalse: [ cell object: nil ]	
		]! !

!AMMHeap methodsFor: 'accessing' stamp: 'sw 5/6/2013 10:10:44.341'!
heapCollection
	
	 ^ heapCollection ifNil: [ heapCollection := OrderedCollection new ]! !

!AMMHeap methodsFor: 'accessing' stamp: 'ci 5/10/2013 17:47:45.901'!
heapCollection: anObject

	heapCollection := anObject! !

!AMMHeap methodsFor: 'accessing' stamp: 'sw 5/6/2013 10:10:59.241'!
heapSize

	^ self heapCollection size! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 5/27/2013 09:57:32.457'!
mapObjectsToHeap
	" iterates over objects and marks used heap cells "

	self objects do: [ :object |
			| cell |
			0 to: (object size - 1) do: [ :offset |
				(self heapCollection size >= (object address + offset)) ifTrue: [
					cell := self heapCollection at: (object address + offset). 
					cell setStatus: 2.
					cell object: object.
				]
			]
		]! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 5/28/2013 22:41:12.765'!
refresh

	self submorphs  
		do:[ :morph | morph refresh ].! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 5/28/2013 23:50:07.309'!
render
	self freeEmptiedCells.
	self mapObjectsToHeap.
	self refresh.! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 5/27/2013 10:32:53.954'!
size: aHeapSize

	self extent: ((aHeapSize*10)@100);
		borderWidth: 0;
		color: Color transparent;
		heapCollection: OrderedCollection new.
		
	self clearHeap.
	self createCells: aHeapSize.
! !

AMMObjectsRepresentation subclass: #AMMObjectGraph
	instanceVariableNames: 'objectNodes layoutAlgorithm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/26/2013 15:20:25.515'!
addNewNodes
"Create one ObjectNode for every new object and register the morph in the temporary storage"
| newObjects |
	newObjects := self objects select: [:obj | (self objectNodes includesKey: obj) not ] .

	newObjects do:[ :obj |
		|node|
				node := AMMObjectNode newFor: obj.
				node object state = #marked ifTrue: [ node color: Color green. ].	
				self objectNodes at: obj put: node.
				self addMorph: node.
		].

	^ newObjects
! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 14:16:38.383'!
clear

	self layoutAlgorithm delete.
	self removeNodes.
	! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 12:40:23.524'!
connectNode: node with: anotherNode

	| connection |
	connection := NCAAConnectorMorph fromMorph: node toMorph: anotherNode.
	connection makeForwardArrow.
	self addMorph: connection.
	! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/29/2013 09:54:04.871'!
connectNodes

	self objectNodes keysAndValuesDo:[ :object :node |
		node removeUnreferencedConnectors.

		object references do: [ :referencedObject |
			node connectedNodes 
				detect: [:otherNode | (otherNode object = referencedObject) ]
				ifNone: [ self connectNode: node with: (self objectNodes at: referencedObject) ].
		] 
	]! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/26/2013 15:10:01.767'!
connectNodes: anCollection

	anCollection 
		do:[ :node|
			self connectReferences: node. 
		]! !

!AMMObjectGraph methodsFor: 'submorphs-add/remove' stamp: 'sw 5/6/2013 19:48:36.428'!
delete

	self clear.
	super delete.! !

!AMMObjectGraph methodsFor: 'initialization' stamp: 'ci 5/13/2013 17:19:58.113'!
initialize 

	super initialize.
	self 
		extent: 400@400;
		color: Color transparent;
	 	borderWidth: 0.! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 13:40:23.548'!
layoutAlgorithm

	^ layoutAlgorithm ifNil: [ layoutAlgorithm := AMMGraphLayoutAlgorithm new.]
! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 19:48:20.328'!
layoutNodes
	WorldState
		addDeferredUIMessage: 
[ self layoutAlgorithm layoutMorph: self]
! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 11:05:48.348'!
objectNodes

	^ objectNodes ifNil: [ objectNodes := Dictionary new.]! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/26/2013 15:10:37.767'!
refresh 

	self objectNodes do: [ :node |
		node refresh.
		].! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 10:02:13.946'!
removeNodes 

	self removeAllMorphs.
	self objectNodes keysDo: [:key | self objectNodes removeKey: key ]! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/29/2013 09:49:50.223'!
removeNodesOfDeletedObjects
	"self halt."
	self objectNodes values do: [ :node |
		(self objects includes: node object) 
			ifFalse: [ node  delete ]	
		]
	! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/29/2013 09:50:17.337'!
render

	| newNodes |

	self removeNodesOfDeletedObjects.
	newNodes := self addNewNodes.
	"self connectNodes: newNodes."

	self connectNodes.

	self layoutNodes.
	self refresh.! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 12:41:50.661'!
runGraph

	WorldState
		addDeferredUIMessage: [self layoutAlgorithm layoutMorph: self]
layoutNodes

	"move nodes"! !

!AMMObjectsRepresentation methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 10:00:57.498'!
clear
	^ self subclassResponsibility ! !

!AMMObjectsRepresentation methodsFor: 'accessing' stamp: 'ci 5/10/2013 18:17:34.105'!
objects

	^ objects ifNil: [ objects:= OrderedCollection  new ]! !

!AMMObjectsRepresentation methodsFor: 'accessing' stamp: 'sw 5/15/2013 10:07:21.553'!
objects: anObject

	self clear.

	objects := anObject.

	self render.! !

!AMMObjectsRepresentation methodsFor: 'as yet unclassified' stamp: 'sw 5/15/2013 10:07:40.779'!
refresh

	self subclassResponsibility ! !

!AMMObjectsRepresentation methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 09:46:42.197'!
render
	^ self subclassResponsibility ! !

!AMMObjectsRepresentation methodsFor: 'accessing' stamp: 'ci 5/10/2013 17:56:19.769'!
studio

	^ studio! !

!AMMObjectsRepresentation methodsFor: 'accessing' stamp: 'ci 5/10/2013 17:56:19.78'!
studio: anObject

	studio := anObject! !

RectangleMorph subclass: #AMMHeapCell
	instanceVariableNames: 'id object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMHeapCell class methodsFor: 'as yet unclassified' stamp: 'ci 5/10/2013 11:25:56.475'!
withId: aNumber
	| cell |
	cell := self new.
	cell extent: (10 @ 92).
	cell color: Color blue.
	cell borderWidth: 1.
	cell id: aNumber.
	^ cell.! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'rm 5/6/2013 13:22:06.905'!
id
	^ id.! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'rm 5/6/2013 13:24:54.733'!
id: aNumber
	id := aNumber.! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'ci 5/13/2013 17:56:37.144'!
object

	^ object! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'sw 5/15/2013 10:13:21.867'!
object: anObject

	object := anObject.

	self setColor.! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'sw 5/15/2013 10:16:17.794'!
refresh 

	self setColor.
	! !

!AMMHeapCell methodsFor: 'logic' stamp: 'rm 5/6/2013 15:06:58.379'!
reset
	self setStatus: 1.! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'sw 5/28/2013 22:33:17.381'!
setColor
	
	(self object isNil) 
		ifTrue: [ self color: Color gray ] 
		ifFalse: [
			(self object state = #marked) 
				ifTrue: [ self color: Color green ]
				ifFalse: [ 
					((self object state = #active) or: (self object flag = #activeTraversal))
						ifTrue: [ self color: Color yellow ]
				ifFalse: [ 					
					(self object flag = #doneTraversal)
						ifTrue: [self color: Color lightGreen ]
						ifFalse: [ self color: Color blue ].					
					] 
					]
		]
	! !

!AMMHeapCell methodsFor: 'logic' stamp: 'rm 5/6/2013 15:04:46.403'!
setStatus: aState

	(aState == 1) ifTrue: [ self color: Color blue].
	(aState == 2) ifTrue: [ self color: Color red].! !

UiTextEdit subclass: #AMMTextEdit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMTextEdit methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2013 11:06:08.274'!
doIt

	self doIt: self selectedText asString.! !

!AMMTextEdit methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2013 11:00:30.778'!
doIt: aString

	self emit. ! !

!AMMTextEdit methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2013 10:51:45.23'!
textMorphClass

	^ AMMTextMorph! !

Object subclass: #AMMGCAlgorithm
	instanceVariableNames: 'phase objects objectStack currentObjectIndex enabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/27/2013 18:16:06.108'!
currentObjectFromMemory

	self objects ifNil: [ ^ nil].
	
	((self currentObjectIndex > 0) and: (self objects size >= self currentObjectIndex)) 
		ifTrue:  [ ^ self objects at: self currentObjectIndex ]
		ifFalse: [	 ^ nil ]! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/27/2013 18:01:18.853'!
currentObjectIndex

	^ currentObjectIndex ifNil: [currentObjectIndex := 0 ]! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/27/2013 18:01:47.427'!
currentObjectIndex: anObject

	currentObjectIndex := anObject! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/28/2013 21:05:13.077'!
disable
	
	self enabled: false! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/28/2013 21:04:57.779'!
enable

	self enabled: true! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/28/2013 21:06:01.344'!
enabled

	^ enabled ifNil: [ enabled := true ]! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/28/2013 21:04:29.537'!
enabled: anObject

	enabled := anObject! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:17:08.483'!
enter: anObject

	self objectStack at: anObject put: 0.
	anObject flag: #activeTraversal.! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:37:39.093'!
findNextUntraversedRoot
	" returns first object which hasn't been traversed yet and is a root - therefore globally reachable "

	self objects 
		do:[ :obj | 
				(obj hasBeenTraversed = false and: ( obj isRoot)) 
					ifTrue: [ ^ obj ] 
			].
	^ nil
		! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:26:20.184'!
indexOfLastChildOf: anObject

	^ self objectStack at: anObject! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/28/2013 21:00:35.074'!
initialize

	super initialize.
	
	self disable.! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/28/2013 21:03:26.472'!
isEnabled
	
	^ enabled == true! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:23:42.31'!
lastVisitedObject

	^ self objectStack orderedKeys last! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:19:54.82'!
leave: anObject

	self objectStack removeKey: anObject.
	anObject flag: #doneTraversal.! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:32:24.811'!
nextChildOf: object
	| nextChild  index | 
	
	index := self indexOfLastChildOf: object.
	nextChild :=  object references at: (index +1) ifAbsent: nil.
	self objectStack at: object put:(index +1).

	^ nextChild! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/28/2013 22:04:31.413'!
nextObject
| object |
	self objectStack isEmpty 
		ifTrue: [
		"no parent-object is on the stack"
			object := self findNextUntraversedRoot.
			(object isNil) 
				ifFalse: [ self enter: object ].
		] ifFalse: [
		
			object := self nextChildOf: self lastVisitedObject.			
			(object isNil)
				ifTrue: [ 
					" last reference of object was visited, we can leave the object now"
					self leave:  self lastVisitedObject. 
					object := self nextObject.
					] 
				ifFalse: [
					object hasBeenTraversed 
						ifTrue:  [ object := self nextObject.] 
						ifFalse: [ self enter: object ].			
					].
			].
		^ object
! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/28/2013 23:31:02.822'!
nextPhase

	self phase: self phase+1.
	self currentObjectIndex: 0.
	self phaseFinished.! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 12:44:01.09'!
objectStack
	^ objectStack ifNil: [ objectStack := OrderedKeysIdentityDictionary new ]! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/27/2013 17:41:32.47'!
objectStack: anObject

	objectStack := anObject! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 10:41:30.436'!
objects 
	^ objects! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 10:41:15.423'!
objects: anCollection
	objects := anCollection! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/27/2013 17:41:41.905'!
phase

	^ phase ifNil: [ phase := 0 ]! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/27/2013 17:41:32.468'!
phase: anObject

	phase := anObject! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/28/2013 10:13:15.262'!
phaseFinished

	self emit! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:11:40.486'!
reset
	self objects do: [ :obj | obj flag: #new ].
	self currentStage: #clearStates.
	self objectStack removeAll.
	! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/28/2013 23:39:20.527'!
step
	" executes the method regarding to the current phase of the alogrithm
	e.g. AMMGCAlgorithm >> phase01Starting
	"
	|method|
	
	self enabled ifFalse: [ ^ self ].

	method := self class methodDictionary keys 
		detect: [:methodName|
			(((methodName asString) findString: ('phase0', self phase)) > 0 ) ]
		ifNone: [ ^ self ].
		
	self perform: method.
	! !

AMMGCAlgorithm subclass: #AMMMarkAndSweap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 5/28/2013 22:03:27.698'!
phase00ClearAllStates
	"clear all flags of the objects"
	
	| object lastObject |
	
	lastObject := self currentObjectFromMemory.
	lastObject ifNotNil: [ lastObject state: #inactive].
	
	self currentObjectIndex: self currentObjectIndex+1.
	
	object := self currentObjectFromMemory.
	(object isNil) 
		ifTrue:  [ self nextPhase ]
		ifFalse:  [ 
			object state: #active.
			object flag: #clear.
		].
	! !

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 5/28/2013 22:42:09.262'!
phase01TraverseTree
	
	| object |

	object := self nextObject.

	object ifNil: [ self nextPhase. ].
! !

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 5/28/2013 23:55:05.175'!
phase02RemoveUnusedObjects
	
	| object lastObject |
	
	lastObject := self currentObjectFromMemory.
	lastObject ifNotNil: [ lastObject state: #inactive].
	
	self currentObjectIndex: self currentObjectIndex+1.
	
	object := self currentObjectFromMemory.
	(object isNil) 
		ifTrue:  [ self nextPhase ]
		ifFalse:  [ 
			object state: #active.
			(object flag = #doneTraversal)
				ifFalse: [ 
					self objects remove: object. 
					self currentObjectIndex: self currentObjectIndex-1.
					object remove ]. 
		].! !

Object subclass: #AMMObject
	instanceVariableNames: 'references size address state flag isRoot studio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/29/2013 08:48:05.981'!
addReference: anObject

	self references add: anObject.
	self changed.! !

!AMMObject methodsFor: 'accessing' stamp: 'rm 5/6/2013 13:47:02.404'!
address

	^ address! !

!AMMObject methodsFor: 'accessing' stamp: 'rm 5/6/2013 13:46:46.902'!
address: anAddress

	address := anAddress.! !

!AMMObject methodsFor: 'event-handling' stamp: 'sw 5/15/2013 09:46:01.333'!
changed

	self emit.! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/9/2013 12:35:16.035'!
flag
	" is used for the garbage collection algorithms"
	^flag! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/28/2013 22:15:46.333'!
flag: aSymbol
	" is used for the garbage collection algorithms"
	flag := aSymbol.
	self changed.! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/13/2013 15:12:55.847'!
hasBeenTraversed

	^ (self flag == #doneTraversal) or: (self flag == #activeTraversal) ! !

!AMMObject methodsFor: 'initialize-release' stamp: 'sw 5/15/2013 09:58:10.281'!
initialize 

	super initialize.

	self flag: #new.
	self isRoot: false.! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/13/2013 14:36:05.021'!
isRoot

	^ isRoot! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/13/2013 14:36:05.027'!
isRoot: anObject

	isRoot := anObject! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/6/2013 10:39:51.902'!
references
	
	^ references ifNil: [ references := OrderedCollection new]! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/13/2013 14:36:05.014'!
references: anObject

	references := anObject! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/28/2013 23:43:44.509'!
remove
	
	self changed ! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/29/2013 08:49:00.377'!
removeReference: anObject

	self references remove: anObject.
	self changed.! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/6/2013 10:40:30.616'!
size
	
	^ size! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/6/2013 10:40:46.006'!
size: aSize
	
	size := aSize.! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/9/2013 12:34:17.707'!
state
	" is used for grafical representation "
	^ state! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/27/2013 17:58:42.479'!
state: aState
	" is used for graphical representation 
		-> #marked when somebody clicked on it
		-> #active when the algorithm is busy with it
		"

	state := aState.
	
	self changed.! !

!AMMObject methodsFor: 'accessing' stamp: 'ci 5/13/2013 17:48:12.558'!
studio
	^studio! !

!AMMObject methodsFor: 'accessing' stamp: 'ci 5/13/2013 17:48:04.379'!
studio: aAMMStudio
	" needed for callback when representation is clicked "

	studio := aAMMStudio.! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/15/2013 09:55:38.274'!
toggleState 

	(self state = #marked) 
		ifTrue: [
			self state: #unmarked.
		 ]
	 	ifFalse: [
			self state: #marked.
		].! !

Object subclass: #AMMUnit
	instanceVariableNames: 'algorithm objects state maxState stepCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMUnit class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:57:49.277'!
heapSize

	self subclassResponsibility ! !

!AMMUnit class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 11:45:19.383'!
nameOfUnit

	self subclassResponsibility ! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/26/2013 14:58:10.616'!
addObject: anObject

	self connect: anObject signal: #changed toSelector: #stateOfObjectChanged: pattern: #(0).
	
	self objects add: anObject.
	
	self objectsChanged.! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/26/2013 14:59:52.76'!
addObjects: anCollectionOfObject

	anCollectionOfObject do: [ :anObject |
		self connect: anObject signal: #changed toSelector: #stateOfObjectChanged: pattern: #(0).
		self objects add: anObject.
	].

	self objectsChanged.! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/28/2013 10:15:33.799'!
algorithm

	^ algorithm! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/28/2013 10:26:29.802'!
algorithm: anObject

	algorithm ifNotNil: [
		self disconnectSignal: #phaseFinished from: algorithm.
	].
	
	algorithm := anObject.

	self connect: self algorithm signal: #phaseFinished toSelector: #reactOnAlgorithmPhaseFinished.
! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/29/2013 08:32:05.344'!
disableAlgorithm

	self algorithm disable.
	self disablePlayControls.! !

!AMMUnit methodsFor: 'event handling' stamp: 'sw 5/27/2013 16:27:37.972'!
disableNextButton

	self emit.! !

!AMMUnit methodsFor: 'event handling' stamp: 'sw 5/29/2013 08:31:38.83'!
disablePlayControls

	self emit! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/24/2013 11:03:41.621'!
doIt: aString
	
	self halt.
! !

!AMMUnit methodsFor: 'unit-interaction' stamp: 'sw 5/27/2013 18:08:52.848'!
doOnce: aBlock

	(self state == maxState) 
		ifTrue: [ ^ aBlock value ]! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/29/2013 08:32:16.202'!
enableAlgorithm

	self algorithm enable.
	self enablePlayControls.! !

!AMMUnit methodsFor: 'event handling' stamp: 'sw 5/27/2013 16:27:26.839'!
enableNextButton

	self emit.! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/29/2013 08:31:36.978'!
enablePlayControls

	self emit! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/16/2013 11:11:33.487'!
finished
	
	self emit.! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/28/2013 10:25:26.434'!
initialize 
	
	super initialize.
	self stepCount: 0.
! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/27/2013 16:20:23.657'!
maxState
	
	^ maxState ifNil: [ maxState := 0 ]! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/27/2013 16:19:45.987'!
maxState: anObject

	maxState := anObject! !

!AMMUnit methodsFor: 'unit-interaction' stamp: 'sw 5/27/2013 16:47:22.696'!
next 

	self state: self state +1.
	self showSequence.! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/26/2013 09:52:42.638'!
objects 

	^ objects ifNil: [ objects := OrderedCollection new ]! !

!AMMUnit methodsFor: 'accessing' stamp: 'ci 5/13/2013 17:50:20.306'!
objects: anObject

	objects := anObject! !

!AMMUnit methodsFor: 'event handling' stamp: 'sw 5/26/2013 10:24:44.569'!
objectsChanged 
	self emit! !

!AMMUnit methodsFor: 'unit-interaction' stamp: 'sw 5/27/2013 16:58:01.879'!
previous  

	(self state > 1)
		ifTrue: [
			self state: (self state -1).
			]
		ifFalse: [ 
			self state: 1.
			].
	self showSequence.! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/28/2013 21:09:11.459'!
reactOnAlgorithmPhaseFinished

	self stopAutoplay.
	
	" do something "
! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/16/2013 10:19:23.847'!
showMessage: aMessage

	self emit.! !

!AMMUnit methodsFor: 'unit-interaction' stamp: 'sw 5/28/2013 10:34:28.373'!
showSequence 

	| method |
	self enableNextButton.

	method := self class methodDictionary keys 
		detect: [:methodName|
			(self state >= 10)
				ifTrue: [
					(((methodName asString) findString: ('sequence', self state)) > 0 )
					]
				ifFalse: [
					(((methodName asString) findString: ('sequence0', self state)) > 0)
					]
				]
		ifNone: [ method:= #finished ].
		
	self perform: method.! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/28/2013 21:11:03.757'!
startAutoplay

	self emit.
! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/26/2013 09:46:46.527'!
state

	^ state ifNil: [ state := 0 ] 
	! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/27/2013 16:33:12.738'!
state: anObject

	(anObject > self maxState) 
		ifTrue: [self maxState: anObject]. 
	state := anObject! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/28/2013 23:54:20.625'!
stateOfObjectChanged: anObject 

	self objectsChanged.
	! !

!AMMUnit methodsFor: 'event handling' stamp: 'sw 5/27/2013 18:04:10.307'!
step

	
! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/16/2013 10:37:15.145'!
stepCount

	^ stepCount! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/16/2013 10:37:15.148'!
stepCount: anObject

	stepCount := anObject! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/28/2013 21:08:50.889'!
stopAutoplay

	self emit.
! !

AMMUnit subclass: #AMMUnit0
	instanceVariableNames: 'pcI challengeAccomplished'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMUnit0 class methodsFor: 'as yet unclassified' stamp: 'sw 5/27/2013 10:33:47.112'!
heapSize 

	^ 40! !

!AMMUnit0 class methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 10:50:11.957'!
nameOfUnit

	^ 'Welcome'! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 5/27/2013 16:39:04.652'!
doIt: aString from: anAMMTextEdit

	((aString findString:'new variable int = 0') > 0)
		ifTrue: [ pcI := 0 ].
	
	((aString findString:'int = int + 2') > 0)
		ifTrue: [ pcI := pcI + 2 ].
		
	((aString findString:'show int') > 0)		
		ifTrue: [ 
			pcI isNil 
				ifTrue: [ anAMMTextEdit textMorph editor afterSelectionInsertAndSelect: 'int is not defined'] 
				ifFalse:  [
					
						(challengeAccomplished) 
							ifFalse:[
								challengeAccomplished := true.
								anAMMTextEdit append: '
							
Awesome!! Good work ;-) 
Click next to continue!!'.
								self enableNextButton.
							].
						anAMMTextEdit textMorph editor afterSelectionInsertAndSelect: 'int is ', pcI .
							.]
			].
		
	^ pcI! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 5/26/2013 15:42:53.284'!
fillInitialObjects 
	
	| objA objB objC col |
	
	objA := AMMObject new size: 8 ;  address: 1; isRoot: true; yourself.
	objB := AMMObject new size: 20 ; address: 10; yourself.
	objC := AMMObject new size: 5 ;  address: 32; yourself.

	objA isRoot: true.
	
	objA references add: objB; add:objC.	

	col := OrderedCollection new.
	col add: objA ; add: objB ; add: objC.
	self 
		addObjects: col.! !

!AMMUnit0 methodsFor: 'accessing' stamp: 'sw 5/24/2013 13:04:42.248'!
initialize 

	super initialize.
	challengeAccomplished := false.! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 5/27/2013 16:54:12.931'!
sequence01Start 

	self showMessage:
'Hello you,
You can learn how the mark and sweep algorithm works here. 

Click on next to learn about this learning environment first!!!!'.
! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 5/27/2013 16:54:37.386'!
sequence02IntroduceElements
	
	self doOnce: [
		self fillInitialObjects.
		].
	
	self showMessage:
'You can see various elements here.
On the left side, you find the lecture-selector. Here you can choose a particular topic, you want to dive into.
Next to it, the stepping-menu is located. With this, you can control how algorithms are applied in later lectures. You can step through every single instruction or you can play it up automatically.

On the right hand side you can see the heap, which is the memory representation.
Under the heap, you see another way of representing objects: an object graph.

Click next to continue!!'.
! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 5/27/2013 16:55:00.057'!
sequence03IntroduceInteractionWithNodes
	
	self doOnce: [
		self addObject: (AMMObject new size: 5 ; address: 37; yourself).
		challengeAccomplished := false.
		self disableNextButton.
		].
	self showMessage:
'Like everywhere, these objects change frequently. 
So, objects are added and removed from the program.
You will learn, which strategies are applied to remove the objects from the memories regardingly.

You can click on every node to see, where it is located in the heap. Try it!!

'.! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 5/27/2013 16:55:32.521'!
sequence04IntroducePseudoCode
	
	self doOnce: [
		challengeAccomplished := false.
		self disableNextButton.
		].
	
	self showMessage:
'This text-field is interactive!!

As everywhere in squeak, you can select text and execute the code.

Please try it!! Select one line of the following pseudo code and execute it!!

new variable int = 0
int = int + 2
show int'.! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 5/27/2013 16:55:43.538'!
sequence05IntroduceUnits

	self showMessage:
'You can access many units here. As mentioned before, you can navigate to tehm directly via the lecture-selector.
Otherwise, you can follow our whole course an ... just click next. 
Your first lecture will start immediately.'.
! !

!AMMUnit0 methodsFor: 'accessing' stamp: 'sw 5/27/2013 18:30:12.368'!
stateOfObjectChanged: anObject 

	((self state == 3)	 and: challengeAccomplished == false)
			ifTrue: [
					self showMessage: 'Well done!! No you can see the marked object (highlighted in green) in the heap and in the object graph!!
				
When you are done with playing around here, click next!!'.
	self enableNextButton.].
		
	self objectsChanged ! !

AMMUnit subclass: #AMMUnit1
	instanceVariableNames: 'nextFreeObjectAddresses john peter greta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMUnit1 class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 14:19:11.438'!
heapSize 

	^ 45! !

!AMMUnit1 class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 11:44:55.082'!
nameOfUnit

	^ 'Unit #1'! !

!AMMUnit1 methodsFor: 'unit-interaction' stamp: 'sw 5/28/2013 23:23:37.978'!
addDemonstrationObject
	| sizeForObject lastValidMemoryAddress |
 
	sizeForObject := 3.

	(self state >= 15)
		ifTrue:  [ lastValidMemoryAddress := 25.]
		ifFalse: [ lastValidMemoryAddress := self class heapSize ].
	(nextFreeObjectAddresses + sizeForObject < lastValidMemoryAddress)
		ifTrue: [
			self addObject:  
				(AMMObject new size: 3 ;  address: nextFreeObjectAddresses; isRoot: true; yourself).
			nextFreeObjectAddresses := nextFreeObjectAddresses + sizeForObject.
			]
		ifFalse: [
			self next
		]

! !

!AMMUnit1 methodsFor: 'unit-interaction' stamp: 'sw 5/29/2013 08:48:43.728'!
doIt: aString from: anAMMTextEdit

	((aString findString: 'peter = new human') > 0 ) 
		ifTrue: [
			peter := AMMObject new size: 12 ;  address: 1; isRoot: true; yourself.
			self addObject: peter.
			].

	((aString findString: 'john = new human') > 0 ) 
		ifTrue: [
			john := AMMObject new size: 12 ;  address: 13; isRoot: false; yourself.
			self addObject: (john).
			].
	((aString findString: 'greta = new human') > 0 ) 
		ifTrue: [
			greta := AMMObject new size: 12 ;  address: 25; isRoot: false; yourself.
			self addObject: (greta).
			].
	((aString findString: 'peter isFriendOf: john') > 0 ) 
		ifTrue: [
			peter addReference: john.
			].
	((aString findString: 'peter isFriendOf: greta') > 0 ) 
		ifTrue: [
			peter addReference: greta.
			self next.
			].
	((aString findString: 'peter endsFriendshipWith: john') > 0 ) 
		ifTrue: [	
			peter removeReference: john.
			self next.
		].		
		

	((aString findString: 'new MyObject') > 0 ) 
		ifTrue: [	
			self addDemonstrationObject.
		].
			
	
	((aString findString: 'objects do: 
	[ :object | object setState: clear ]') > 0 ) 
		ifTrue: [	
			self enableAlgorithm.
			self startAutoplay.
			].
	
	((aString findString: 'rootObjects do: [:object |
	object mark.
	]') > 0 ) 
		ifTrue: [	
			self algorithm enable.
			self startAutoplay.
			].
	((aString findString: 'objects do: 
	[ :object | 
		(object markingState !!= #set) 
			ifTrue: [ object delete ] ]	') > 0 ) 
		ifTrue: [	
			self enableAlgorithm.
			self startAutoplay.
			].
		
	self objectsChanged.

! !

!AMMUnit1 methodsFor: 'unit-interaction' stamp: 'sw 5/27/2013 10:54:51.877'!
fillInitialObjects 
	
	| objA objB objC objD col |
	
	nextFreeObjectAddresses := 42.
	
	objA := AMMObject new size: 8 ;  address: 1; isRoot: true; yourself.
	objB := AMMObject new size: 20 ; address: 10; yourself.
	objC := AMMObject new size: 5 ;  address: 31; yourself.
	objD := AMMObject new size: 5 ; address: 37; yourself.

	objA isRoot: true.
	
	objA references add: objB; add:objC.	

	col := OrderedCollection new.
	col add: objA ; add: objB ; add: objC ; add: objD.
	self 
		addObjects: col.! !

!AMMUnit1 methodsFor: 'accessing' stamp: 'sw 5/28/2013 21:06:37.043'!
initialize 

	super initialize.
	self algorithm: AMMMarkAndSweap new.
	self algorithm 
		objects: self objects;
		disable.
	nextFreeObjectAddresses := 37.! !

!AMMUnit1 methodsFor: 'accessing' stamp: 'sw 5/29/2013 08:33:09.532'!
reactOnAlgorithmPhaseFinished

	super reactOnAlgorithmPhaseFinished.
	
	(self state == 9) 
		ifTrue: [
			self disableAlgorithm.
			self next.
			]. 
		
	(self state == 11) 
		ifTrue: [
			self algorithm disable.
			self next.
			]. 
	(self state == 14) 
		ifTrue: [
			self disableAlgorithm.
			self next.
			]. ! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/27/2013 17:00:47.116'!
sequence01Start 

	self showMessage:
'Mark and Sweep is a two phase algorithm
During the first phase reachable objects are visited. 
Each visited object gets marked.
Referenced objects are visited recursively. If an object has been marked already, the recursion is cancelled.

During the second phace all unmarked objects are removed from the memory.'.
! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/27/2013 17:00:50.575'!
sequence02ExplainInitiationOfGC 

	self showMessage: 'Mark and sweep is a start-stop algorithm. Therefore the user program is interrupted for the garbage collection. 
	
The garbage collection is started when not enough space is left for a required memory allocation.'.
! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/27/2013 17:01:14.529'!
sequence03InitiateGC 
	
	self doOnce: [ self disableNextButton ].
	self showMessage: 'Ok, so lets create some objects.
For example we use objects like this in our program:

global peter = new human
john = new human
greta = new human
peter isFriendOf: john
peter isFriendOf: greta

Please execute the code.
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/27/2013 17:01:38.945'!
sequence04RemoveOneObjects
	
	self doOnce: [ self disableNextButton ].

	self showMessage: 'In the meantime, Peter and John had a big fight and do not speak with each other anymore.
	
Therefore we want to remove the reference from Peter to John. Execute:

peter endsFriendshipWith: john

'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/27/2013 17:01:46.328'!
sequence05ExplainUnneededMemory
	
	self showMessage: 'Hence, John is the only object which is reachable globally, Peter is not accessable anymore and could be removed from the memory.
	

'.
! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/27/2013 17:01:50.945'!
sequence06CreateMoreObjects 

	self doOnce: [ self disableNextButton ].
	
	self showMessage: 'Ok, now we have a couple of objects in our memory.

And we want to create further objects.

Therefore, please create a new object with executing the following line (just select it and hit cmd-d):

new MyObject
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/29/2013 10:03:51.692'!
sequence07OutOfMemory 
	
"	self doOnce: [ self disableNextButton. self enablePlayControls ].
"	
	self showMessage: 'Ups, we are out of memory now.
Almost at least. Our memory is filled with objects, but not all of them are needed anymore.

Here the automatical garbage collection helps out.

As you have learned before, mark and sweep is an start-stop algorithm, which interrupts the user program completely.
This happens now.
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/27/2013 17:26:52.958'!
sequence08KindOfReachableObjects
	
	self showMessage: 'The first phase of mark and sweep is about finding referenced objects.
There are 2 different types of reachable objects.

1st: root objects (which are highlighted with a red border in the object graph).
These objects are accessable globally.

2nd: referenced objects
To find out, which objects are reachable, we have to traverse all references of reachable objects.
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/27/2013 17:33:45.094'!
sequence09FirstPhase
	
	self doOnce: [ self disableNextButton ].

	self showMessage: 'The garbage collector has to mark objects in the memory and needs a storage for that.
Therefore before the first phase can start, the garbage collector has to reset the storage. 

You can think about it, as the 0th phase.
	
We iterate over all objects in our memory (heap) and reset the storage.
	
objects do: 
	[ :object | object setState: clear ]	

'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/28/2013 21:43:23.495'!
sequence10ExplainRecursiveMark
	
	self showMessage: 'Well, now we have a consistent state.
	
We can search for all reachable objects!! This is done recursively.

During the marking phase, when an object has not been marked before it is marked. Afterwards all referenced objects are visited and marked.

Object >> mark
	(self markingState !!= #set)
		ifTrue: [
			self markingState: #set.
			self references do: [ :object | 
				object mark.
				].
		]

Your are just one "next"-click away from seeing your first garbage collection!!
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/28/2013 21:45:07.093'!
sequence11ExecuteMark
	
	self doOnce: [ self disableNextButton ].
	
	self showMessage: 'This mark is executed for every root-object - so for every object which is reachable globally.
	
Therefore, please go ahead and execute the following lines of code!!
	
rootObjects do: [:object |
	object mark.
	]

'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/28/2013 22:46:46.298'!
sequence12ExplainResultOfMark
	
	self showMessage: 'Do you see the big gap between the first object (Peter) and the third (Greta). This space is used to store data for the second obejct(John) we created. Hence this data is not accessible anymore, it is completely useless and can be freed.
	
Click next to learn about the 2nd phase of Mark and Sweep.
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/28/2013 22:59:45.712'!
sequence13IntroduceSweep
	
	self showMessage: 'At this point of time, we have analysed our memory and found all objects which are still in use.

Now, we have to iterate over all cells of our memory to check, if there are some unused objects in there.

Just to clarify things, a quick reminder.
In the 0th phase, we reset the state of all objects in memory.
In the 1st phase, we mark all reachable objects, which is usually only a subset of all objects.
In the 2nd phase (now), we iterate over all objects in our memory again, to remove all unreachable ones. 

Go ahead and click "Next"!!!!
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/28/2013 23:04:26.882'!
sequence14ExecuteSweep
	
	self doOnce: [ self disableNextButton ].

	self showMessage: 'Now, we have to iterate over all objects in our memory (heap) and delete them from the storage if they were not accessed in the 2nd phase.

Execute it!!!!

objects do: 
	[ :object | 
		(object markingState !!= #set) 
			ifTrue: [ object delete ] ]	
	
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/28/2013 23:17:05.354'!
sequence15ResultOfSweep

	nextFreeObjectAddresses := 13.
	self doOnce: [ self disableNextButton ].
	self showMessage: 'Awesome, you just finished your first (automatic) garbage collection!! Congratulation, user program has enough space available and can store new objects again!!
	
Now, the interruption of the program ends.
Create further objects again!!

new MyObject

'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/28/2013 23:18:30.834'!
sequence16AgainOutOfSpace
	
	self showMessage: 'This can go on, until you are out of space again.
	
At this stage, we would execute the garbage collection again. 
But, unfortunately we would not free any space - hence all objects are reachable and necessary.

'! !

!AMMUnit1 methodsFor: 'unit-interaction' stamp: 'sw 5/23/2013 20:08:07.657'!
step
	
	self algorithm step.! !

UserInterface subclass: #AMMStudioUi
	instanceVariableNames: 'comboUnits buttonStop buttonPlay buttonStep descriptionField buttonPrevious buttonNext devButton containerHeap containerGraph scrollAreaGraph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/27/2013 19:12:47.59'!
buttonNext
	"No description given."
	
	^ buttonNext! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/27/2013 19:12:47.58'!
buttonPlay
	"Play Scenario"
	
	^ buttonPlay! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/27/2013 19:12:47.587'!
buttonPrevious
	"No description given."
	
	^ buttonPrevious! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/27/2013 19:12:47.582'!
buttonStep
	"GC Stepping"
	
	^ buttonStep! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/27/2013 19:12:47.577'!
buttonStop
	"No description given."
	
	^ buttonStop! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/27/2013 19:12:47.575'!
comboUnits
	"No description given."
	
	^ comboUnits! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/27/2013 19:12:47.596'!
containerGraph
	"No description given."
	
	^ containerGraph! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/27/2013 19:12:47.594'!
containerHeap
	"Container for the heap presentation"
	
	^ containerHeap! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/27/2013 19:12:47.585'!
descriptionField
	"No description given."
	
	^ descriptionField! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/27/2013 19:12:47.592'!
devButton
	"No description given."
	
	^ devButton! !

!AMMStudioUi methodsFor: 'ui - private' stamp: 'sw 5/27/2013 19:12:47.653'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 unnamedMorph2 unnamedMorph3 unnamedMorph4 unnamedMorph5 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (500@466).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#shrinkWrap).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (4).
	panel cellPositioning: (#topLeft).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#leftToRight).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (385@458).
	unnamedMorph1 position: (4@4).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#spaceFill).
	unnamedMorph1 minWidth: (300).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (4).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#topToBottom).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.925)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	unnamedMorph2 := UiContainer new.
	unnamedMorph2 changeTableLayout.
	unnamedMorph2 extent: (377@30).
	unnamedMorph2 position: (8@8).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#shrinkWrap).
	unnamedMorph2 minWidth: (2).
	unnamedMorph2 minHeight: (2).
	unnamedMorph2 cellInset: (4).
	unnamedMorph2 cellPositioning: (#topLeft).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (4).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#leftToRight).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	unnamedMorph2 color: (Color transparent).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 setProperty: #objectDescription toValue: 'Container for the heap presentation'.
	comboUnits := UiComboBox new.
	comboUnits extent: (110@21).
	comboUnits position: (12@12).
	comboUnits hResizing: (#rigid).
	comboUnits vResizing: (#rigid).
	comboUnits minWidth: (2).
	comboUnits minHeight: (2).
	comboUnits cellInset: (0).
	comboUnits cellPositioning: (#center).
	comboUnits cellSpacing: (#none).
	comboUnits layoutInset: (0).
	comboUnits listCentering: (#topLeft).
	comboUnits listDirection: (#topToBottom).
	comboUnits listSpacing: (#none).
	comboUnits maxCellSize: (1073741823).
	comboUnits minCellSize: (0).
	comboUnits wrapCentering: (#topLeft).
	comboUnits wrapDirection: (#none).
	comboUnits frameFractions: (0@0 corner: 1@1).
	comboUnits frameOffsets: (0@0 corner: 0@0).
	comboUnits balloonText: (nil).
	comboUnits balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	comboUnits readOnly: (true).
	comboUnits setProperty: #objectName toValue: 'comboUnits'.
	unnamedMorph2 addChild: comboUnits.
	buttonStop := UiPushButton new.
	buttonStop changeTableLayout.
	buttonStop extent: (53@21).
	buttonStop position: (128@12).
	buttonStop hResizing: (#shrinkWrap).
	buttonStop vResizing: (#shrinkWrap).
	buttonStop minWidth: (2).
	buttonStop minHeight: (2).
	buttonStop cellInset: (4).
	buttonStop cellPositioning: (#center).
	buttonStop cellSpacing: (#none).
	buttonStop layoutInset: (2@0 corner: 2@0).
	buttonStop listCentering: (#topLeft).
	buttonStop listDirection: (#leftToRight).
	buttonStop listSpacing: (#none).
	buttonStop maxCellSize: (1073741823).
	buttonStop minCellSize: (0).
	buttonStop wrapCentering: (#topLeft).
	buttonStop wrapDirection: (#none).
	buttonStop frameFractions: (0@0 corner: 1@1).
	buttonStop frameOffsets: (0@0 corner: 0@0).
	buttonStop balloonText: (nil).
	buttonStop balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	buttonStop enabled: (true).
	buttonStop setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0342Normal'.
	buttonStop icon: (UiDiagonaIcons icon0342Normal).
	buttonStop text: ('Stop').
	buttonStop color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	buttonStop checkable: (false).
	buttonStop checked: (false).
	buttonStop autoExclusive: (false).
	buttonStop setProperty: #objectName toValue: 'buttonStop'.
	unnamedMorph2 addChild: buttonStop.
	buttonPlay := UiPushButton new.
	buttonPlay changeTableLayout.
	buttonPlay extent: (49@21).
	buttonPlay position: (187@12).
	buttonPlay hResizing: (#shrinkWrap).
	buttonPlay vResizing: (#shrinkWrap).
	buttonPlay minWidth: (2).
	buttonPlay minHeight: (2).
	buttonPlay cellInset: (4).
	buttonPlay cellPositioning: (#center).
	buttonPlay cellSpacing: (#none).
	buttonPlay layoutInset: (2@0 corner: 2@0).
	buttonPlay listCentering: (#topLeft).
	buttonPlay listDirection: (#leftToRight).
	buttonPlay listSpacing: (#none).
	buttonPlay maxCellSize: (1073741823).
	buttonPlay minCellSize: (0).
	buttonPlay wrapCentering: (#topLeft).
	buttonPlay wrapDirection: (#none).
	buttonPlay frameFractions: (0@0 corner: 1@1).
	buttonPlay frameOffsets: (0@0 corner: 0@0).
	buttonPlay balloonText: (nil).
	buttonPlay balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	buttonPlay enabled: (true).
	buttonPlay setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0331Normal'.
	buttonPlay icon: (UiDiagonaIcons icon0331Normal).
	buttonPlay text: ('Play').
	buttonPlay color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	buttonPlay checkable: (false).
	buttonPlay checked: (false).
	buttonPlay autoExclusive: (false).
	buttonPlay setProperty: #objectName toValue: 'buttonPlay'.
	buttonPlay setProperty: #objectDescription toValue: 'Play Scenario'.
	unnamedMorph2 addChild: buttonPlay.
	buttonStep := UiPushButton new.
	buttonStep changeTableLayout.
	buttonStep extent: (52@21).
	buttonStep position: (242@12).
	buttonStep hResizing: (#shrinkWrap).
	buttonStep vResizing: (#shrinkWrap).
	buttonStep minWidth: (2).
	buttonStep minHeight: (2).
	buttonStep cellInset: (4).
	buttonStep cellPositioning: (#center).
	buttonStep cellSpacing: (#none).
	buttonStep layoutInset: (2@0 corner: 2@0).
	buttonStep listCentering: (#topLeft).
	buttonStep listDirection: (#leftToRight).
	buttonStep listSpacing: (#none).
	buttonStep maxCellSize: (1073741823).
	buttonStep minCellSize: (0).
	buttonStep wrapCentering: (#topLeft).
	buttonStep wrapDirection: (#none).
	buttonStep frameFractions: (0@0 corner: 1@1).
	buttonStep frameOffsets: (0@0 corner: 0@0).
	buttonStep balloonText: (nil).
	buttonStep balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	buttonStep enabled: (true).
	buttonStep setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0343Normal'.
	buttonStep icon: (UiDiagonaIcons icon0343Normal).
	buttonStep text: ('Step').
	buttonStep color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	buttonStep checkable: (false).
	buttonStep checked: (false).
	buttonStep autoExclusive: (false).
	buttonStep setProperty: #objectName toValue: 'buttonStep'.
	buttonStep setProperty: #objectDescription toValue: 'GC Stepping'.
	unnamedMorph2 addChild: buttonStep.
	unnamedMorph1 addChild: unnamedMorph2.
	unnamedMorph3 := UiContainer new.
	unnamedMorph3 changeTableLayout.
	unnamedMorph3 extent: (377@415).
	unnamedMorph3 position: (8@43).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#spaceFill).
	unnamedMorph3 minWidth: (2).
	unnamedMorph3 minHeight: (2).
	unnamedMorph3 cellInset: (4).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (4).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.925)).
	unnamedMorph3 color: (Color transparent).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	descriptionField := AMMTextEdit new.
	descriptionField extent: (369@373).
	descriptionField position: (12@47).
	descriptionField hResizing: (#spaceFill).
	descriptionField vResizing: (#spaceFill).
	descriptionField minWidth: (2).
	descriptionField minHeight: (2).
	descriptionField cellInset: (0).
	descriptionField cellPositioning: (#center).
	descriptionField cellSpacing: (#none).
	descriptionField layoutInset: (0).
	descriptionField listCentering: (#topLeft).
	descriptionField listDirection: (#topToBottom).
	descriptionField listSpacing: (#none).
	descriptionField maxCellSize: (1073741823).
	descriptionField minCellSize: (0).
	descriptionField wrapCentering: (#topLeft).
	descriptionField wrapDirection: (#none).
	descriptionField frameFractions: (0@0 corner: 1@1).
	descriptionField frameOffsets: (0@0 corner: 0@0).
	descriptionField balloonText: (nil).
	descriptionField balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	descriptionField widgetResizable: (true).
	descriptionField horizontalScrollBarPolicy: (#alwaysOff).
	descriptionField verticalScrollBarPolicy: (#alwaysOn).
	descriptionField outerBorderWidth: (1).
	descriptionField scrollBarThickness: (9).
	descriptionField theText: ('').
	descriptionField readOnly: (false).
	descriptionField autoConvert: (false).
	descriptionField autoAccept: (false).
	descriptionField acceptOnFocusLost: (false).
	descriptionField scrollingMode: (#none).
	descriptionField scrollingLimit: (10).
	descriptionField setProperty: #objectName toValue: 'descriptionField'.
	unnamedMorph3 addChild: descriptionField.
	unnamedMorph4 := UiContainer new.
	unnamedMorph4 changeTableLayout.
	unnamedMorph4 extent: (369@30).
	unnamedMorph4 position: (12@424).
	unnamedMorph4 hResizing: (#spaceFill).
	unnamedMorph4 vResizing: (#rigid).
	unnamedMorph4 minWidth: (2).
	unnamedMorph4 minHeight: (2).
	unnamedMorph4 cellInset: (4).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (4).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#leftToRight).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.929)).
	unnamedMorph4 color: (Color transparent).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	buttonPrevious := UiPushButton new.
	buttonPrevious changeTableLayout.
	buttonPrevious extent: (75@21).
	buttonPrevious position: (16@428).
	buttonPrevious hResizing: (#shrinkWrap).
	buttonPrevious vResizing: (#shrinkWrap).
	buttonPrevious minWidth: (2).
	buttonPrevious minHeight: (2).
	buttonPrevious cellInset: (4).
	buttonPrevious cellPositioning: (#center).
	buttonPrevious cellSpacing: (#none).
	buttonPrevious layoutInset: (2@0 corner: 2@0).
	buttonPrevious listCentering: (#topLeft).
	buttonPrevious listDirection: (#leftToRight).
	buttonPrevious listSpacing: (#none).
	buttonPrevious maxCellSize: (1073741823).
	buttonPrevious minCellSize: (0).
	buttonPrevious wrapCentering: (#topLeft).
	buttonPrevious wrapDirection: (#none).
	buttonPrevious frameFractions: (0@0 corner: 1@1).
	buttonPrevious frameOffsets: (0@0 corner: 0@0).
	buttonPrevious balloonText: (nil).
	buttonPrevious balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	buttonPrevious enabled: (true).
	buttonPrevious setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0332Normal'.
	buttonPrevious icon: (UiDiagonaIcons icon0332Normal).
	buttonPrevious text: ('Previous').
	buttonPrevious color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	buttonPrevious checkable: (false).
	buttonPrevious checked: (false).
	buttonPrevious autoExclusive: (false).
	buttonPrevious setProperty: #objectName toValue: 'buttonPrevious'.
	unnamedMorph4 addChild: buttonPrevious.
	buttonNext := UiPushButton new.
	buttonNext changeTableLayout.
	buttonNext extent: (53@21).
	buttonNext position: (97@428).
	buttonNext hResizing: (#shrinkWrap).
	buttonNext vResizing: (#shrinkWrap).
	buttonNext minWidth: (2).
	buttonNext minHeight: (2).
	buttonNext cellInset: (4).
	buttonNext cellPositioning: (#center).
	buttonNext cellSpacing: (#none).
	buttonNext layoutInset: (2@0 corner: 2@0).
	buttonNext listCentering: (#topLeft).
	buttonNext listDirection: (#leftToRight).
	buttonNext listSpacing: (#none).
	buttonNext maxCellSize: (1073741823).
	buttonNext minCellSize: (0).
	buttonNext wrapCentering: (#topLeft).
	buttonNext wrapDirection: (#none).
	buttonNext frameFractions: (0@0 corner: 1@1).
	buttonNext frameOffsets: (0@0 corner: 0@0).
	buttonNext balloonText: (nil).
	buttonNext balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	buttonNext enabled: (true).
	buttonNext setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0331Normal'.
	buttonNext icon: (UiDiagonaIcons icon0331Normal).
	buttonNext text: ('Next').
	buttonNext color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	buttonNext checkable: (false).
	buttonNext checked: (false).
	buttonNext autoExclusive: (false).
	buttonNext setProperty: #objectName toValue: 'buttonNext'.
	unnamedMorph4 addChild: buttonNext.
	devButton := UiPushButton new.
	devButton changeTableLayout.
	devButton extent: (117@21).
	devButton position: (156@428).
	devButton hResizing: (#shrinkWrap).
	devButton vResizing: (#shrinkWrap).
	devButton minWidth: (2).
	devButton minHeight: (2).
	devButton cellInset: (4).
	devButton cellPositioning: (#center).
	devButton cellSpacing: (#none).
	devButton layoutInset: (2@0 corner: 2@0).
	devButton listCentering: (#topLeft).
	devButton listDirection: (#leftToRight).
	devButton listSpacing: (#none).
	devButton maxCellSize: (1073741823).
	devButton minCellSize: (0).
	devButton wrapCentering: (#topLeft).
	devButton wrapDirection: (#none).
	devButton frameFractions: (0@0 corner: 1@1).
	devButton frameOffsets: (0@0 corner: 0@0).
	devButton balloonText: (nil).
	devButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	devButton enabled: (true).
	devButton setProperty: #iconByDesigner toValue: 'nil'.
	devButton icon: (nil).
	devButton text: ('developmentMode').
	devButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	devButton checkable: (false).
	devButton checked: (false).
	devButton autoExclusive: (false).
	devButton setProperty: #objectName toValue: 'devButton'.
	unnamedMorph4 addChild: devButton.
	unnamedMorph3 addChild: unnamedMorph4.
	unnamedMorph1 addChild: unnamedMorph3.
	panel addChild: unnamedMorph1.
	unnamedMorph5 := UiContainer new.
	unnamedMorph5 changeTableLayout.
	unnamedMorph5 extent: (103@458).
	unnamedMorph5 position: (393@4).
	unnamedMorph5 hResizing: (#spaceFill).
	unnamedMorph5 vResizing: (#spaceFill).
	unnamedMorph5 minWidth: (2).
	unnamedMorph5 minHeight: (2).
	unnamedMorph5 cellInset: (4).
	unnamedMorph5 cellPositioning: (#center).
	unnamedMorph5 cellSpacing: (#none).
	unnamedMorph5 layoutInset: (4).
	unnamedMorph5 listCentering: (#topLeft).
	unnamedMorph5 listDirection: (#topToBottom).
	unnamedMorph5 listSpacing: (#none).
	unnamedMorph5 maxCellSize: (1073741823).
	unnamedMorph5 minCellSize: (0).
	unnamedMorph5 wrapCentering: (#topLeft).
	unnamedMorph5 wrapDirection: (#none).
	unnamedMorph5 frameFractions: (0@0 corner: 1@1).
	unnamedMorph5 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph5 balloonText: (nil).
	unnamedMorph5 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	unnamedMorph5 color: (Color transparent).
	unnamedMorph5 borderWidth: (0).
	unnamedMorph5 borderStyle2: (#simple).
	unnamedMorph5 borderColor: (Color black).
	containerHeap := UiContainer new.
	containerHeap changeTableLayout.
	containerHeap extent: (95@100).
	containerHeap position: (397@8).
	containerHeap hResizing: (#spaceFill).
	containerHeap vResizing: (#rigid).
	containerHeap minWidth: (2).
	containerHeap minHeight: (2).
	containerHeap cellInset: (4).
	containerHeap cellPositioning: (#center).
	containerHeap cellSpacing: (#none).
	containerHeap layoutInset: (4).
	containerHeap listCentering: (#topLeft).
	containerHeap listDirection: (#topToBottom).
	containerHeap listSpacing: (#none).
	containerHeap maxCellSize: (1073741823).
	containerHeap minCellSize: (0).
	containerHeap wrapCentering: (#topLeft).
	containerHeap wrapDirection: (#none).
	containerHeap frameFractions: (0@0 corner: 1@1).
	containerHeap frameOffsets: (0@0 corner: 0@0).
	containerHeap balloonText: (nil).
	containerHeap balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	containerHeap color: (Color lightGray).
	containerHeap borderWidth: (0).
	containerHeap borderStyle2: (#simple).
	containerHeap borderColor: (Color black).
	containerHeap setProperty: #objectName toValue: 'containerHeap'.
	containerHeap setProperty: #objectDescription toValue: 'Container for the heap presentation'.
	unnamedMorph5 addChild: containerHeap.
	containerGraph := UiContainer new.
	containerGraph changeTableLayout.
	containerGraph extent: (95@346).
	containerGraph position: (397@112).
	containerGraph hResizing: (#spaceFill).
	containerGraph vResizing: (#spaceFill).
	containerGraph minWidth: (2).
	containerGraph minHeight: (2).
	containerGraph cellInset: (4).
	containerGraph cellPositioning: (#center).
	containerGraph cellSpacing: (#none).
	containerGraph layoutInset: (4).
	containerGraph listCentering: (#topLeft).
	containerGraph listDirection: (#topToBottom).
	containerGraph listSpacing: (#none).
	containerGraph maxCellSize: (1073741823).
	containerGraph minCellSize: (0).
	containerGraph wrapCentering: (#topLeft).
	containerGraph wrapDirection: (#none).
	containerGraph frameFractions: (0@0 corner: 1@1).
	containerGraph frameOffsets: (0@0 corner: 0@0).
	containerGraph balloonText: (nil).
	containerGraph balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	containerGraph color: (Color lightGray).
	containerGraph borderWidth: (0).
	containerGraph borderStyle2: (#simple).
	containerGraph borderColor: (Color black).
	containerGraph setProperty: #objectName toValue: 'containerGraph'.
	scrollAreaGraph := ViScrollArea new.
	scrollAreaGraph extent: (87@338).
	scrollAreaGraph position: (401@116).
	scrollAreaGraph hResizing: (#spaceFill).
	scrollAreaGraph vResizing: (#spaceFill).
	scrollAreaGraph minWidth: (2).
	scrollAreaGraph minHeight: (2).
	scrollAreaGraph cellInset: (0).
	scrollAreaGraph cellPositioning: (#center).
	scrollAreaGraph cellSpacing: (#none).
	scrollAreaGraph layoutInset: (0).
	scrollAreaGraph listCentering: (#topLeft).
	scrollAreaGraph listDirection: (#topToBottom).
	scrollAreaGraph listSpacing: (#none).
	scrollAreaGraph maxCellSize: (1073741823).
	scrollAreaGraph minCellSize: (0).
	scrollAreaGraph wrapCentering: (#topLeft).
	scrollAreaGraph wrapDirection: (#none).
	scrollAreaGraph frameFractions: (0@0 corner: 1@1).
	scrollAreaGraph frameOffsets: (0@0 corner: 0@0).
	scrollAreaGraph balloonText: (nil).
	scrollAreaGraph balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	scrollAreaGraph widgetResizable: (false).
	scrollAreaGraph horizontalScrollBarPolicy: (#alwaysOn).
	scrollAreaGraph verticalScrollBarPolicy: (#alwaysOn).
	scrollAreaGraph outerBorderWidth: (0).
	scrollAreaGraph scrollBarThickness: (9).
	scrollAreaGraph setProperty: #objectName toValue: 'scrollAreaGraph'.
	containerGraph addChild: scrollAreaGraph.
	unnamedMorph5 addChild: containerGraph.
	panel addChild: unnamedMorph5.
	panel setProperty: #uiClassName toValue: 'AMMStudio'.! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/27/2013 19:12:47.598'!
scrollAreaGraph
	"No description given."
	
	^ scrollAreaGraph! !

Morph subclass: #AMMStudio
	instanceVariableNames: 'ui heap objectgraph currentUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMStudio class methodsFor: 'as yet unclassified' stamp: 'sw 5/26/2013 16:01:38.96'!
open

	^ self new openInWindowLabeled: 'AMM Studio'.! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 11:48:54.013'!
currentUnit

	^ currentUnit! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 11:49:15.468'!
currentUnit: anAMMUnit

	currentUnit := anAMMUnit! !

!AMMStudio methodsFor: 'event handling' stamp: 'sw 5/28/2013 23:41:14.751'!
developmentMode

	self startNextUnit.
		
	self currentUnit state:8.
	self currentUnit next.
	
	self currentUnit doIt: '
	
global peter = new human
john = new human
greta = new human
peter isFriendOf: john
peter isFriendOf: greta
peter endsFriendshipWith: john
new MyObject
new MyObject
' from: nil.
	self currentUnit doIt: 'new MyObject' from: nil.
	self currentUnit doIt: 'new MyObject' from: nil.
	
	self currentUnit state:8.
	self currentUnit next.
	
	self currentUnit doIt: 'objects do: 
	[ :object | object setState: clear ]' from: nil.	
	self currentUnit state:10.
	self currentUnit next.
	self refreshObjectRepresentations.
	! !

!AMMStudio methodsFor: 'event handling' stamp: 'sw 5/27/2013 16:37:18.478'!
disableNextButton

	self ui buttonNext enabled: false.! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 5/29/2013 08:30:40.727'!
disablePlayControls

	World stopStepping: self.
	self ui buttonStop enabled: false.	
	self ui buttonStep enabled: false.		
	self ui buttonPlay enabled: false.		! !

!AMMStudio methodsFor: 'event handling' stamp: 'sw 5/27/2013 16:31:51.575'!
enableNextButton

	self ui buttonNext enabled: true.! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 5/29/2013 08:31:00.091'!
enablePlayControls

	self ui buttonStop enabled: false.	
	self ui buttonStep enabled: true.		
	self ui buttonPlay enabled: true.		! !

!AMMStudio methodsFor: 'event handling' stamp: 'sw 5/24/2013 12:58:14.404'!
forwardDoIt: aString
	
	self currentUnit doIt: aString from: self ui descriptionField.
! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 5/27/2013 19:14:19.322'!
gcStep

	self currentUnit step.
	self refreshObjectRepresentations.
	Transcript show: 'step '.! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 13:53:16.717'!
heap

	^ heap! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 13:54:09.601'!
heap: aHeap

	heap := aHeap! !

!AMMStudio methodsFor: 'initialization' stamp: 'sw 5/29/2013 08:44:53.475'!
initialize 

	super initialize.
	self ui setupUi: self.

	self extent:800@500.
	
	self registerSignalsForGeneralControls.
	self initializeObjectRepresentations.	
	self initializeUnits.
	
	self startUnit: AMMUnit0 new.
	
	self disablePlayControls.
	
! !

!AMMStudio methodsFor: 'initialization' stamp: 'sw 5/13/2013 14:10:07.642'!
initializeObjectRepresentations

	self heap: (AMMHeap new).
	self ui containerHeap addMorph: self heap.
	
	self objectgraph: (AMMObjectGraph new).
	self ui scrollAreaGraph widget: self objectgraph.
! !

!AMMStudio methodsFor: 'initialization' stamp: 'sw 5/16/2013 11:13:11.437'!
initializeUnits
	
	|subclasses|
	
	subclasses := AMMUnit allSubclasses.
	subclasses sort: [ :classA :classB | classA name asString < classB name asString ].
	self ui comboUnits 
		addItemListFrom: subclasses
		using: [:unit :listItem | 
			listItem text: unit nameOfUnit. 
			listItem data: unit. ].
		
! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 5/16/2013 10:48:04.084'!
next

	(self currentUnit isNil) 
		ifFalse: [ self currentUnit next ]! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 5/27/2013 16:46:08.043'!
nextSequence

	self currentUnit next! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 14:00:51.495'!
objectgraph

	^ objectgraph ! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 14:01:26.257'!
objectgraph: anObjectgraph

	objectgraph := anObjectgraph! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 5/27/2013 16:46:17.193'!
previousSequence

	self currentUnit previous! !

!AMMStudio methodsFor: 'event handling' stamp: 'sw 5/28/2013 22:41:29.259'!
refreshObjectRepresentations

	self objectgraph render.
	self heap render.
! !

!AMMStudio methodsFor: 'event handling' stamp: 'sw 5/29/2013 08:44:26.427'!
registerSignalsForCurrentunit

	self connect: self currentUnit signal: #showMessage: toSelector: #showMessage: pattern: #(1).
	
	self connect: self currentUnit signal: #objectsChanged toSelector: #refreshObjectRepresentations.
	
	self connect: self currentUnit signal: #stopAutoplay toSelector: #stopAutoplay.
	self connect: self currentUnit signal: #startAutoplay toSelector: #startAutoplay.
	
	
	self connect: self currentUnit signal: #finished toSelector: #startNextUnit.

	self connect: self currentUnit signal: #enableNextButton toSelector: #enableNextButton.
	self connect: self currentUnit signal: #disableNextButton toSelector: #disableNextButton.

	self connect: self currentUnit signal: #enablePlayControls toSelector: #enablePlayControls.
	self connect: self currentUnit signal: #disablePlayControls toSelector: #disablePlayControls.! !

!AMMStudio methodsFor: 'event handling' stamp: 'sw 5/28/2013 10:20:59.244'!
registerSignalsForGeneralControls

	self connect: self ui buttonStep signal:#clicked: toSelector: #gcStep.
	self connect: self ui buttonPlay signal:#clicked: toSelector: #startAutoplay.	
	self connect: self ui buttonNext signal:#clicked: toSelector: #nextSequence.
	
	self connect: self ui buttonStop signal:#clicked: toSelector: #stopAutoplay.

	self connect: self ui buttonPrevious signal:#clicked: toSelector: #previousSequence.
	self connect: self ui devButton signal:#clicked: toSelector: #developmentMode.
	
	
	self connect: self ui comboUnits signal: #currentTextChanged: toSelector: #selectUnit.
	
	self connect: self ui descriptionField signal: #doIt: toSelector: #forwardDoIt: pattern: #(1).! !

!AMMStudio methodsFor: 'event handling' stamp: 'sw 5/16/2013 11:31:34.541'!
selectUnit

	self startUnit: (self ui comboUnits currentItem data new).! !

!AMMStudio methodsFor: 'event handling' stamp: 'sw 5/24/2013 10:50:23.135'!
showMessage: aMessage

	self ui descriptionField theText: aMessage ! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 5/28/2013 23:22:02.405'!
startAutoplay
	
	" trigger frequently step method "

	World
		startStepping: self
		at: Time millisecondClockValue
		selector: #gcStep
		arguments: { }
		stepTime: 1000.

	self ui buttonStop enabled: true.	
	self ui buttonStep enabled: false.		
	self ui buttonPlay enabled: false.		! !

!AMMStudio methodsFor: 'event handling' stamp: 'sw 5/26/2013 15:58:41.272'!
startNextUnit

	self ui comboUnits currentIndex: (self ui comboUnits currentIndex +1).
	! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/27/2013 18:36:11.945'!
startUnit: anUnit

	self unregisterSignalsForCurrentunit.
	
	self currentUnit: anUnit.
		
	self objectgraph objects: (self currentUnit objects).
	self heap size: self currentUnit class heapSize.
	self heap objects: (self currentUnit objects).

	self registerSignalsForCurrentunit.

	self currentUnit next.! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 5/28/2013 23:22:19.917'!
stopAutoplay

	World stopStepping: self.
	self ui buttonStop enabled: false.	
	self ui buttonStep enabled: true.		
	self ui buttonPlay enabled: true.		! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 4/29/2013 12:05:54.615'!
ui
	
	^ ui ifNil: [ ui:= AMMStudioUi new ]! !

!AMMStudio methodsFor: 'accessing' stamp: 'ci 5/10/2013 17:44:40.556'!
ui: anObject

	ui := anObject! !

!AMMStudio methodsFor: 'event handling' stamp: 'sw 5/28/2013 21:15:00.888'!
unregisterSignalsForCurrentunit

	(self currentUnit isNil) 
		ifFalse: [ 
			self currentUnit objects 
				do:[ :obj | 
					self disconnectSignal: #changed from: obj.
				].
			self disconnectSignal: #showMessage: from: self currentUnit.
			self disconnectSignal: #finished  from: self currentUnit.
			self disconnectSignal: #stopAutoplay from: self currentUnit.
			self disconnectSignal: #startAutoplay from: self currentUnit.

			self disconnectSignal: #enableNextButton from: self currentUnit.
			self disconnectSignal: #disableNextButton from: self currentUnit.

			self disconnectSignal: #objectsChanged from: self currentUnit.

		].


! !

Morph subclass: #AMMTestConnect
	instanceVariableNames: 'obj1 obj2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMTestConnect methodsFor: 'as yet unclassified' stamp: 'ci 5/13/2013 20:02:13.705'!
clickedObj1
	Transcript show: 'Clicked Objekt # 1';cr.! !

!AMMTestConnect methodsFor: 'as yet unclassified' stamp: 'ci 5/13/2013 20:13:12.101'!
clickedObj2: evt
	Transcript show: 'Clicked Objekt # 2';cr.! !

!AMMTestConnect methodsFor: 'as yet unclassified' stamp: 'ci 5/13/2013 20:36:49.91'!
initialize
	super initialize.
	
	self obj1:  UiPushButton new.
	self obj1 position: 5@5.
	self obj1 text: 'Send!!'.
	self obj2: Morph new.
	self obj2 position: 100@5.
	self 
		extent: 400@400;
		color: Color gray;
		addMorph: obj1;
		addMorph: obj2.
		
	self connect: self obj1 signal:#clicked: toSelector: #clickedObj1.
	self obj2 on:#mouseDown send:#clickedObj2: to:self.! !

!AMMTestConnect methodsFor: 'accessing' stamp: 'ci 5/13/2013 19:56:59.507'!
obj1

	^ obj1! !

!AMMTestConnect methodsFor: 'accessing' stamp: 'ci 5/13/2013 19:56:59.52'!
obj1: anObject

	obj1 := anObject! !

!AMMTestConnect methodsFor: 'accessing' stamp: 'ci 5/13/2013 19:56:59.532'!
obj2

	^ obj2! !

!AMMTestConnect methodsFor: 'accessing' stamp: 'ci 5/13/2013 19:56:59.548'!
obj2: anObject

	obj2 := anObject! !

!OrderedKeysIdentityDictionary methodsFor: '*AMMStudio' stamp: 'sw 5/9/2013 13:16:13.633'!
at: key put: anObject 
	(self includesKey: key) 
		ifFalse: [
		self orderedKeys add: key.
		].
	super at: key put: anObject.
	! !

!OrderedKeysIdentityDictionary methodsFor: '*AMMStudio' stamp: 'sw 5/9/2013 13:17:21.275'!
removeKey: key 

	self orderedKeys remove: key.
	^ super removeKey: key.	
! !

UiTextMorph subclass: #AMMTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMTextMorph methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2013 10:45:40.6'!
editorClass

	^ AMMTextEditor! !

TestCase subclass: #AMMGCAlgorithmTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 14:49:11.736'!
exampleObjects
	
| objA objB objC coll objD |
	objA := AMMObject new size: 8 ; address: 1; yourself.
	objB := AMMObject new size: 20 ; address: 10; yourself.
	objC := AMMObject new size: 5 ; address: 32; yourself.
	objD := AMMObject new size: 5 ; address: 37; yourself.

	objA isRoot: true.
	
	objA references add: objB; add:objC.	

	coll := OrderedCollection new
		add: objA; 
		add: objB;
		add: objC;
		add: objD;
		yourself.

	^ coll! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:23:53.463'!
exampleObjectsWithOnlyOneChild
	
| objA objB objC coll objD |
	objA := AMMObject new size: 8 ; address: 1; yourself.
	objB := AMMObject new size: 20 ; address: 10; yourself.
	objC := AMMObject new size: 5 ; address: 32; yourself.
	objD := AMMObject new size: 5 ; address: 37; yourself.

	objA isRoot: true.
	
	objA references add: objB.

	coll := OrderedCollection new
		add: objA; 
		add: objB;
		add: objC;
		add: objD;
		yourself.

	^ coll! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:09:47.004'!
exampleObjectsWithOrphan
	
| objA objB coll objC |
	objA := AMMObject new size: 8 ; address: 1; yourself.
	objB := AMMObject new size: 20 ; address: 10; yourself.
	objC := AMMObject new size: 20 ; address: 10; yourself.
	
	objA isRoot: true.
	objA references add: objB.
	
	coll := OrderedCollection new
		add: objA; 
		add: objB;
		add: objC;
		
		yourself.



	^ coll! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:43:45.55'!
exampleObjectsWithTwoRoots
	
| objA objB coll |
	objA := AMMObject new size: 8 ; address: 1; yourself.
	objB := AMMObject new size: 20 ; address: 10; yourself.
	
	objA isRoot: true.
	
	objB isRoot: true.
	
	coll := OrderedCollection new
		add: objA; 
		add: objB;
		yourself.

	^ coll! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 12:56:53.589'!
setUp 

	sut := AMMGCAlgorithm new.
	sut objects: self exampleObjects.! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:14:15.315'!
test010EnterChildOfFirstNode

	| objA objB |
	objA := sut nextObject. 
	
	self assert: (objA == (sut objects at:1)).
	self assert: (objA flag = #activeTraversal). " state is changed "
	
	self assert: ((objA references at:1) flag = #new). " state is still active "
	
	objB := sut nextObject. 
	
	self assert: (objA flag = #activeTraversal). " state is still active "
	
	self assert: (objB == (objA references at:1)).

	self assert: (objB flag = #activeTraversal).
! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:46:30.414'!
test011ReturnToParentNodeAndContinue

	| objA objB objC |
	sut objects: self exampleObjectsWithOnlyOneChild.
	
	objA := sut nextObject. 
	objB := sut nextObject. 
	
	self assert: (objA flag = #activeTraversal). " state is still active "
	self assert: (objB flag = #activeTraversal).
	
	objC := sut nextObject. 
	
	self assert: (objC = nil).
	
	self assert: (objA flag = #doneTraversal). " state is left "
	self assert: (objB flag = #doneTraversal). " state is left "! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:07:48.381'!
test020EnterTwoRoots

	| objA objB objC |
	sut objects: self exampleObjectsWithTwoRoots.
	
	objA := sut nextObject. 
	self assert: (objA flag = #activeTraversal). " state is still active "
	self assert: (objA = (sut objects at:1)).
	
	objB := sut nextObject. 
	self assert: (objB = (sut objects at:2)).
	self assert: (objB flag = #activeTraversal).

	self assert: (objA flag = #doneTraversal). " state is still active "
	
	objC := sut nextObject. 
	
	self assert: (objC = nil).
	
! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:11:06.447'!
test030DoNotVisitOrphanObject

	| objA objB objC |
	sut objects: self exampleObjectsWithOrphan.
	
	objA := sut nextObject. 
	self assert: (objA = (sut objects at:1)).
	
	objB := sut nextObject. 
	self assert: (objB = (sut objects at:2)).

	objC := sut nextObject. 
	
	self assert: (objC = nil).
	
! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:09:58.91'!
testFirstVisitedObjectGetsEntered

	| obj |
	obj := sut nextObject. 
	
	self assert: (obj == (sut objects at:1)).
	self assert: (obj flag == #activeTraversal).

	" first object is in the stack "
	self assert: ((sut objectStack orderedKeys last) == obj).
	
	" children counter is zero "
	self assert: ((sut objectStack at: obj) == 0).
	! !

NCSimulatedAnnealingGraphLayoutAlgorithm subclass: #AMMGraphLayoutAlgorithm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMGraphLayoutAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:33:02.774'!
aeMinEdgeLength
	"sw: I had to change this, hence errors came up, after removing the PasteUpMorph, although the layout algorithm is still active."
	
	"I am an aesthetic that causes edges to be shortened. My magnitude is d^2, where d is the magnitude of the distance between nodes. Since I consider all edges, my time complexity is O(|E|)"

	| retval |
	retval := IdentityDictionary 
				newFrom: (self nodes collect: [:node | node -> (0 @ 0)]).
	self edges do: 
			[:edge | 
			| fromNode toNode delta mag force |
			fromNode := edge startConnection.
			toNode := edge endConnection.
			((fromNode isNil) or: toNode isNil) ifFalse: [
				delta := toNode center - fromNode center.
				delta := delta / scale.
				mag := delta r.
				force := mag * delta.
				retval at: fromNode put: (retval at: fromNode) + force.
				retval at: toNode put: (retval at: toNode) - force].
			].	

   ^self nodes collect: [:ea | retval at: ea]! !

!AMMGraphLayoutAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:33:02.784'!
aeNodeRepulsion
	"I am an aesthetic that attempts to keep nodes apart. My magnitude is 1/d^2, where d is the magnitude of the distance between nodes. Since I consider all node combinations, my time complexity is O(|V|^2)"

	| retval |
	retval := Array new: self nodes size withAll: 0.0 @ 0.0.
	(1 to: self nodes size) combinations: 2
		atATimeDo: 
			[:arr | 
			| ai1 ai2 node otherNode delta mag2 force |
			 "self halt."
			node := self nodes at: (ai1 := arr at: 1).
			otherNode := self nodes at: (ai2 := arr at: 2).
			delta := (node center - otherNode center) asFloatPoint.
			delta := (delta / scale) + 0.001.
			mag2 := delta x * delta x + (delta y * delta y) max: 1.0e-8.
			force := 1.0 / mag2 * delta.
			retval at: ai1 put: (retval at: ai1) + force.
			retval at: ai2 put: (retval at: ai2) - force].
	^retval! !

!AMMGraphLayoutAlgorithm methodsFor: 'as yet unclassified' stamp: 'ci 5/28/2013 20:36:29.937'!
layoutMorph: aPasteUpMorph 
	"sdad"
	aPasteUpMorph allConnectedMorphs isEmpty ifFalse: [
		self preArrangeConnectedMorphs: aPasteUpMorph.
		^ super layoutMorph: aPasteUpMorph
		]! !

!AMMGraphLayoutAlgorithm methodsFor: 'as yet unclassified' stamp: 'ci 5/28/2013 21:26:44.329'!
preArrangeConnectedMorphs: aPasteUpMorph
	"ci: a first implementation.
	the algorithm of the future:
		all roots do:
			collect levels and number of nodes on each level.
			maxLevelNodes = maximum number of nodes per level.
			maxWidth = cDistance (class constant) * maxLevelNodes.
			xDistance per level = maxWidth/ levelNodes.
			parameters: offset, return value: new offset
	"
	| tSize node tPosition |
	tSize := aPasteUpMorph objects size.
	(1 to: tSize) do: [:index |
		node := aPasteUpMorph objectNodes at: (aPasteUpMorph objects at:index).
		
		node object isRoot ifFalse:[
			tPosition := (index*(40@0)) + (0@50).
		]ifTrue:[ 
			tPosition := (index*(40@0)) + (0@10). 
		].
		
		node position: tPosition.
	].! !
